set(DELFILES
    # Setup test
    "test_setup/dcb.prepi"
    "test_setup/dcb.frcmod"
    "test_setup/dcb.zmat"
    "test_setup/dcb.tem"
    "test_setup/dcb_box.pdb"
    "test_setup/protein_scoop.pdb"
    "test_setup/water.pdb"
    "test_setup/protoms_py.log"
    # Equilibration test
    "test_equil/run_bnd.cmd"
    "test_equil/out_bnd"
    "test_equil/protoms_py.log"
    # Energies test
    "test_energies/out_t3p"
    "test_energies/out_t4p"
    # Sampling test
    "test_sampling/run_bnd.cmd"
    "test_sampling/out_bnd"
    "test_sampling/protoms_py.log"
    # GCMC test
    "test_gcmc/gcmc_box.pdb"
    "test_gcmc/gcmc_wat.pdb"
    "test_gcmc/run_gcmc.cmd"
    "test_gcmc/protoms_py.log"
    "test_gcmc/make_gcmcbox_py.log"
    "test_gcmc/out_gcmc"
    # JAWS1 test
    "test_jaws1/water_clr.pdb"
    "test_jaws1/fragment_box.pdb"
    "test_jaws1/fragment.frcmod"
    "test_jaws1/fragment.prepi"
    "test_jaws1/fragment.tem"
    "test_jaws1/fragment.zmat"
    "test_jaws1/protein_scoop.pdb"
    "test_jaws1/protoms_py.log"
    "test_jaws1/jaws1_box.pdb"
    "test_jaws1/jaws1_wat.pdb"
    "test_jaws1/run_jaws.cmd"
    "test_jaws1/out_jaws"
    # JAWS2 test
    "test_jaws2/jaws2_wat3.pdb"
    "test_jaws2/jaws2_wat2.pdb"
    "test_jaws2/jaws2_wat1.pdb"
    "test_jaws2/jaws2_not3.pdb"
    "test_jaws2/jaws2_not2.pdb"
    "test_jaws2/jaws2_not1.pdb"
    "test_jaws2/jaws1_box.pdb"
    "test_jaws2/jaws1_wat.pdb"
    "test_jaws2/fragment_box.pdb"
    "test_jaws2/fragment.frcmod"
    "test_jaws2/fragment.prepi"
    "test_jaws2/fragment.tem"
    "test_jaws2/fragment.zmat"
    "test_jaws2/protein_scoop.pdb"
    "test_jaws2/protoms_py.log"
    "test_jaws2/run_jaws2-w1_jaws.cmd"
    "test_jaws2/run_jaws2-w2_jaws.cmd"
    "test_jaws2/run_jaws2-w3_jaws.cmd"
    "test_jaws2/out_jaws2-w1"
    # RETI single test
    "test_RETI_sngl/ethtmeo_comb.tem"
    "test_RETI_sngl/ethtmeo_ele.tem"
    "test_RETI_sngl/ethtmeo_vdw.tem"
    "test_RETI_sngl/ethane_box.pdb"
    "test_RETI_sngl/ethane.frcmod"
    "test_RETI_sngl/ethane.prepi"
    "test_RETI_sngl/ethane.zmat"
    "test_RETI_sngl/methanol_box.pdb"
    "test_RETI_sngl/methanol.frcmod"
    "test_RETI_sngl/methanol.prepi"
    "test_RETI_sngl/methanol.zmat"
    "test_RETI_sngl/run_comb_free.cmd"
    "test_RETI_sngl/run_comb_gas.cmd"
    "test_RETI_sngl/run_ele_free.cmd"
    "test_RETI_sngl/run_ele_gas.cmd"
    "test_RETI_sngl/run_vdw_free.cmd"
    "test_RETI_sngl/run_vdw_gas.cmd"
    "test_RETI_sngl/prep_files.tar"
    "test_RETI_sngl/protoms_py.log"
    "test_RETI_sngl/out_comb_free"
    "test_RETI_sngl/out_comb_gas"
    # RETI double test
    "test_RETI_dbl/eth-meo.tem"
    "test_RETI_dbl/ethane_box.pdb"
    "test_RETI_dbl/ethane.frcmod"
    "test_RETI_dbl/ethane.prepi"
    "test_RETI_dbl/ethane.zmat"
    "test_RETI_dbl/methanol_box.pdb"
    "test_RETI_dbl/methanol.frcmod"
    "test_RETI_dbl/methanol.prepi"
    "test_RETI_dbl/methanol.zmat"
    "test_RETI_dbl/prep_files.tar"
    "test_RETI_dbl/protoms_py.log"
    "test_RETI_dbl/run_free.cmd"
    "test_RETI_dbl/out_free"
    )

foreach(f ${DELFILES})
    set(f ../tests/${f})
    if(EXISTS ${f})
        message("Removing ${f}")
        file(REMOVE_RECURSE ${f})
    endif()
endforeach()
